# TPK4186 - Advanced Tools for Performance Engineering
# ApproximationOfPiRandomized.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import random

random.seed(12345)

def AssessPi(numberOfExecutions):
  count = 0
  for execution in range(0, numberOfExecutions):
    x = random.random()
    y = random.random()
    if x**2 + y**2 <= 1:
      count += 1
  observedFrequency = count/numberOfExecutions
  pi = observedFrequency*4
  return pi

def MultipleAssessPi(numberOfExecutions, numberOfExperiments):
  print("\nExperiments with " + str(numberOfExecutions) + " executions")
  print("Experiment\tPi")
  sum = 0
  for experiment in range(1, numberOfExperiments+1):
    pi = AssessPi(numberOfExecutions)
    sum += pi
    print(str(experiment) + "\t" + str(pi))
  print("Mean")
  print(str(numberOfExperiments) + "\t" + str(sum/numberOfExperiments))

numbersOfExecutions = []
numberOfExecutions = 1000
while numberOfExecutions<=10000000:
  MultipleAssessPi(numberOfExecutions, 20)
  numberOfExecutions *= 10
