# TPK4186 - Advanced Tools for Performance Engineering
# ApproximationOfPiRecursive.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

def ApproximatePiInZone(minX, maxX, minY, maxY, probability, threshold):
  maxRadius = maxX**2 + maxY**2
  if maxRadius<=1:
    return (probability, probability, 1)
  minRadius = minX**2 + minY**2
  if minRadius>1:
    return (0, 0, 1)
  q = probability/4
  if q<threshold:
      return (0, probability, 1)
  midX = (minX+maxX)/2
  midY = (minY+maxY)/2
  (l1, h1, n1) = ApproximatePiInZone(minX, midX, minY, midY, q, threshold)
  (l2, h2, n2) = ApproximatePiInZone(minX, midX, midY, maxY, q, threshold)
  if minX==minY and maxX==maxY:
    (l3, h3, n3) = (l2, h2, 0)
  else:
    (l3, h3, n3) = ApproximatePiInZone(midX, maxX, minY, midY, q, threshold)
  (l4, h4, n4) = ApproximatePiInZone(midX, maxX, midY, maxY, q, threshold)
  return (l1 + l2 + l3 + l4, h1 + h2 + h3 + h4, n1 + n2 + n3 + n4)

print("lower bound\tupper bound\t#calls")
threshold = 1.0e-3
while threshold >= 1.0e-13:
  (l, h, n) = ApproximatePiInZone(0.0, 1.0, 0.0, 1.0, 1.0, threshold)
  print(str(l*4) + "\t" + str(h*4) + "\t" + str(n))
  threshold *= 0.1