# TPK4186 - Advanced Tools for Performance Engineering
# EllipticIntegral.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import random
import math

# The function
def f(x):
  return math.sqrt(1.0 - math.pow(x, 4))

# Q1
def Fd(n):
  dx = 1.0/n
  x = 0.0
  s = 0.0
  while x<=1.0:
    s += f(x)
    x += dx
  return s/(n+1)

# Q2
def Fr(n):
  s = 0.0
  for i in range(0, n+1):
    x = random.random()
    s += f(x)
  return s/(n+1)

# Q3
n = 1000
while n<=1000000:
  print(str(n) + "\t" + str(Fd(n)) + "\t" + str(Fr(n)))
  n *= 10



