# TPK4186 - Advanced Tools for Performance Engineering
# ExpoDistribution.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import math
import random

failureRate = 1.0e-4
z0 = 0.5
t0 = -math.log(0.5)/failureRate
numberOfTrials = 10000000

count1 = 0
count2 = 0
count3 = 0
for trial in range(0, numberOfTrials):
  z1 = random.random()
  t1 = -math.log(z1)/failureRate
  if t1<=t0:
    count1 += 1
  else:
    z2 = random.random()
    t2 = t0 - math.log(z2)/failureRate
    if t1<=t2:
      count2 += 1
    else:
      count3 += 1

print(count1/numberOfTrials)
print(count2/numberOfTrials)
print(count3/numberOfTrials)
