# TPK4186 - Advanced Tools for Performance Engineering
# VolumeOfHyperSpheres.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import random
import math

# 
def InHyperSphere(point, R):
  sum = 0
  for x in point:
    sum += x**2
  return math.sqrt(sum) <= R

def EstimateVolumeHyperSphere(n, R, numberOfRuns):
  point = [0 for i in range(0, n)]
  sum = 0.0
  for run in range(0, numberOfRuns):
    for i in range(0, n):
      point[i] = random.uniform(-R, R)
    if InHyperSphere(point, R):
      sum += 1
  return (sum/numberOfRuns)*(2*R)**n

n = 10
R = 2
numberOfRuns = 100000
volume = EstimateVolumeHyperSphere(n, R, numberOfRuns)
print(str(n) + "\t" + str(R) + "\t" + str(volume))




